#**************************************
# 《スキンボードの共通サブルーチン》
#   bbslibf.pl Ver1.00
#
# ↓著作権は削除しないで下さい。
# 作者:atom 作成日:06/16/2001
# mailto:mail@atom.hostmycgi5.com
#**************************************

#---［注意事項］-------------------------------------------
#  1.スキンボード及びこれらに関するスクリプトの著作権は
#　　作者atomが所有します。
#  2.フリー版スキンボード及びそれらに関するスクリプトの
#　　転載・再利用・再配布は、そのすべて及び一部に関わらず
#　　禁止いたします。
#  3.フリー版スキンボード及びそれらに関するスクリプトの
#　　改造･改変を作者の承諾なしに行うことを禁じます。
#  4.フリー版スキンボードの使用は、これを使用したページに
#　　「スキンボード」、「skin board」、「skinBRD」などの
#　　スキンボードであることの明記と作者「atom」の明記を
#　　必ず行ってください。
#　　その形、文字種、表示形式を問いません。
#  5.これらのスクリプトを使用したいかなる損害も作者は責任
#　　を負いません。
#　　自己の管理の下、使用してください。
#----------------------------------------------------------

sub Param_get{
#入力パラメータの解析（ここでは未使用）
  my($str0) = @_;
  my(@list,@wrk);
  @wrk = split(/&/, $str0);
  foreach (@wrk){
    @val = (/(.+)=(.+)/);
    $in{$1} = $2;
  }
}

sub scal_hen {
#変数文字を変換する
  my ($str0) = @_;
  $str0 =~ s/(\r\n|\r|\n)//gm;
  $str0 =~ s/\$title/$title/igm;
  return $str0;
}

sub logset{
#メッセージログを変換する
  my(@idx,@wrk,$ccnt0);
  my($str0) = @_;

  if ($msgcnv ne "") {
    @idx = split(/,/, $msgcnv);
  } else {
    @idx = (0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15); #スキンボード標準
  }
  if ($msgsep ne "") {
    @wrk = split(/$msgsep/, $str0);
  } else {
    @wrk = split(/\t/, $str0); #スキンボード標準
  }
  $ccnt0 = 0;
  foreach (@idx){
    $val[$_] = $wrk[$ccnt0];
    $ccnt0++;
  }
}

sub bbslog_mak{
#投稿メッセージの生成
  my (@idx,$sep,$str0);
  $ctrlsw = "$ctrl1/$ctrl2/$ctrl3/$ctrl4/$ctrl5/$ctrl6/$clkcnt";
  @wrk[0]   = $msgno;
  @wrk[1]   = $resno;
  @wrk[2]   = $date;
  @wrk[3]   = $subj;
  @wrk[4]   = $comment;
  @wrk[5]   = $tcolor;
  @wrk[6]   = $icon;
  @wrk[7]   = $name;
  @wrk[8]   = $email;
  @wrk[9]   = $url;
  @wrk[10]   = $banner;
  @wrk[11]   = $pwd;
  @wrk[12]   = $ctrlsw;
  @wrk[13]   = $brow;
  @wrk[14]   = $rmhost;
  @wrk[15]   = $addr;
  if ($msgcnv ne "") {
    @idx = split(/,/, $msgcnv);
  } else {
    @idx = (0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15); #スキンボード標準
  }
#0$count\t1$resno\t2$date\t3$subj\t4$comment\t5$tcolor\t6$icon\t7$name\t8$email\t9$url\t10$pwd\t11$rmhost\t12$addr\n
#0$count\t1$resno\t2$date\t3$subj\t4$comment\t5$tcolor\t6$icon\t7$name\t8$email\t9$url\t10$banner\t11$pwd\t12ctrlsw\t13$brow\t14$rmhost\t15$addr\n
  if ($msgsep ne "") {
    $str0 = join $msgsep,@wrk[@idx];
  } else {
    $str0 = join "\t",@wrk[@idx];
  }
#print "@wrk[@idx]<br>";
  $str0 .= "\n";
  return($str0);
}

sub set_cookies {
  $cookies_id = "sknbrd";
  $cname = $name;
  $cname =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
  $cname =~ tr/ /+/; 
  $durl =$url;
  $dbanner = $banner;
  $durl    =~ s/^http\:\/\///gm;
  $dbanner  =~ s/^http\:\/\///gm;
  $ncookies = "tcolor:$tcolor";
  $ncookies .= ",icon:$icon";
  $ncookies .= ",name:$cname";
  $ncookies .= ",email:$email";
  $ncookies .= ",url:$durl";
  $ncookies .= ",banner:$dbanner";
  $ncookies .= ",pwd:$pwd";
  $ncookies .= ",ctrlsw:$ctrlsw";
  $gmt_date = &gmt_date(time + 365 * 86400); #365日 * 1日の秒数
  print "Set-Cookie: $cookies_id=$ncookies; expires=$gmt_date\n";
}

sub escape {
  local($_) = @_;
#  s/(\W)/sprintf("%%%02X",unpack('C',$1))/ge;
  return $_;
}

sub gmt_date {
#日付･時刻の取得
  $ENV{'TZ'} = "JST-9";
  local($t) = @_;
  ($sec,$min,$hour,$mday,$mon,$year,$wday) = gmtime($t);
  $year = sprintf("%04d", $year + 1900);
#  $mon = sprintf("%02d", $mon + 1);
  $mday = sprintf("%02d", $mday);
  $hour = sprintf("%02d", $hour);
  $min = sprintf("%02d", $min);
  $sec = sprintf("%02d", $sec);

# 日時のフォーマット
  $youbi = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat') [$wday];
  $tuki  = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec') [$mon];
  return("$youbi, $mday $tuki $year $hour\:$min\:$sec GMT");
}

sub get_cookies {
#print qq(Content-type: text/html\n\n);
#print $ENV{'HTTP_COOKIE'}."<BR>";
  $cookies_id = "sknbrd";
  foreach (split(/; /, $ENV{'HTTP_COOKIE'})) {
    s/ //igm;
    ($key, $val) = split(/=/);
    $all_cookies{$key} = $val;
  }
#print $all_cookies{$cookies_id}."<BR>";
  if ($all_cookies{$cookies_id} ne "") {
    foreach (split(/,/, $all_cookies{$cookies_id})) {
      ($key, $val) = split(/:/);
#      $gcookies{&unescape($key)} = &unescape($val);
      $gcookies{$key} = $val;
#print $key."/".$val."<br>";
    }
    $tcolor = $gcookies{'tcolor'};
    $icon   = $gcookies{'icon'  };
    $name   = $gcookies{'name'  };
#print "+++++++++++++$name";
    $name =~ s/\+/ /g;
    $name =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
#print "----------$name";
    $email   = $gcookies{'email'  };
    $url     = $gcookies{'url'    };
    $banner = $gcookies{'banner'};
    $pwd     = $gcookies{'pwd'    };
    $ctrlsw  = $gcookies{'ctrlsw'};
    @wrk = split(/\//, $ctrlsw);
    $ctrl1   = $wrk[0];
    $ctrl2   = $wrk[1];
    $ctrl3   = $wrk[2];
    $ctrl4   = $wrk[3];
    $ctrl5   = $wrk[4];
    $ctrl6   = $wrk[5];
    $clkcnt = $wrk[6];
  } else {
    $tcolor = "";
    $icon   = "";
    $name   = "";
    $email   = "";
    $url     = "";
    $banner = "";
    $pwd     = "";
    $ctrlsw = "";
    $ctrl1   = "";
    $ctrl2   = "";
    $ctrl3   = "";
    $ctrl4   = "";
    $ctrl5   = "";
    $ctrl6   = "";
    $clkcnt = "";
  }
#print "name = $name";
#print "$cookies_id<br>";
#print "$all_cookies{$cookies_id}<br>";
}

sub unescape {
  local($_) = @_;
#  s/%([0-9a-fA-F][0-9a-fA-F])/pack('C',hex($1))/ge;
  return $_;
}

sub bbscnt_get {
#掲示板用ＢＢＳカウンタの取得
#ＢＢＳカウンタがなければ、作成する
  if (!-e $bbscnt0) {
    open(FILE, ">$bbscnt0") || werror("ＢＢＳカウンタに書き込みできません。(bbscnt_get)",$bbscnt0);
    chmod(0666, $bbscnt0) || werror("chmod error(bbscnt_get)",$bbscnt0);
    close(FILE);
  }
#ＢＢＳカウンタが存在すれば、ＢＢＳカウンタ値を得る
  open(FILE, "$bbscnt0") || werror("ＢＢＳカウンタがオープンできません。(bbscnt_get)",$bbscnt0);
    $count = <FILE>; #ＢＢＳカウンタ値の取得
  close(FILE); #ＢＢＳカウンタファイルを閉じる
  $count++; #ＢＢＳカウンタ値に１を加算
  $zcount = sprintf("%6.6d", $count);
}

sub bbscnt_up {
#掲示板用ＢＢＳカウンタの記録
#ＢＢＳカウンタがなければ、作成する
  if (!-e $bbscnt0) {
    open(FILE, ">$bbscnt0") || werror("ＢＢＳカウンタに書き込みできません。(bbscnt_up)",$bbscnt0);
    chmod(0666, $bbscnt0) || werror("chmod error(bbscnt_up)",$bbscnt0);
    close(FILE);
  }
#ＢＢＳカウンタが存在すれば、ＢＢＳカウンタ値を得る
  open(FILE, "<$bbscnt0") || werror("ＢＢＳカウンタがオープンできません。(bbscnt_up)",$bbscnt0);
    $count = <FILE>; #ＢＢＳカウンタ値の取得
  close(FILE); #ＢＢＳカウンタファイルを閉じる
  $count++; #ＢＢＳカウンタ値に１を加算
  $zcount = sprintf("%6.6d", $count);

  open(FILE,">$bbscnt0") || werror("ＢＢＳカウンタに書き込みできません。(bbscnt_up)",$bbscnt0); #ＢＢＳカウンタファイルを開く
  print FILE $count; #ＢＢＳカウンタ値を記録する
  close(FILE); #ＢＢＳカウンタファイルを閉じる
}

sub logdsp {
#投稿メッセージを表示
#検索文字を分解する
  $order =~ s/\|/\t\|/g;
  $order =~ s/\&/\t\&/g;
  @sord = split("\t","\t\|$order");

  &logall_get;
#print "$pcnt0 / $dmsgmax / $scnt0  / $scnt1 / $scnt2<br>";
  my(@wrklog) = @logmsg;
  if (($dmsgmax ne "") && (",srcdsp,tree" !~ $act) && ($parent eq "") && ($logext eq "")){
    if ($scnt2 eq "") { $scnt2 = $#logmsg + 1; }
    splice(@wrklog, $scnt2);
    splice(@wrklog, 0, $scnt1);
  }
#print "aaa$npagno / $opagno<br>";
  $scnt0 = 0;
  foreach (@wrklog) {
    next if /^$/;
    &meidsp;
    $scnt0++;
  } #foreachの終了
  close(MSGFL);
  &oldlst_get;
  if ($scnt0 != 0) {
    $sknsep = "mend"; #メッセージエンド部
    &skindsp; #スキンの表示
  }
  if (",srcdsp" !~ $act) {
    $sknsep = "foot"; #メッセージ最終部
    &skindsp; #スキンの表示
  }
}

sub logall_get{
  my($filnam) = $bbslog0;
  if ($lognam ne "") { $filnam = "$bbsdir/$lognam"; }

# ファイルを開く
  if (!-e $filnam) {
    open(FILE, ">$filnam") || werror("ログファイルに書き込みできません。(logall_get)",$filnam);
    chmod(0666, $filnam) || werror("chmod error(logdsp)",$filnam);
    close(FILE);
  }
  open(FILE, "<$filnam") || werror("ログファイルがオープンできません。(logall_get)",$filnam);
    @logmsg = <FILE>;
  close(FILE);

  if ($pageno eq "") { $pageno = 1; }
  if ($dmsgmax ne ""){ &pagno_get; }
}

sub pagno_get{
  $pcnt0 = $scnt0 = 0; $scnt1 = $scnt2 = "";
  foreach (@logmsg) {
    logset($_); #ログメッセージのセット
    if (@val[1] eq ""){ $pcnt0++; } #親メッセージをカウント
    if (($dmsgmax ne "") && ($pcnt0 >  (($pageno - 1) * $dmsgmax)) && ($scnt1 eq "")) { $scnt1 = $scnt0; }
    if (($dmsgmax ne "") && ($pcnt0 >  (($pageno + 0) * $dmsgmax)) && ($scnt2 eq "")) { $scnt2 = $scnt0; }
#print "$pcnt0 / $dmsgmax / $scnt0  / $scnt1 / $scnt2<br>";
    $scnt0++;
  }

  $opagno = "";$npagno = "";
  if (($pageno - 1) > 0) {
    $npagno = $pageno - 1;
  }
  if ((($pageno - 1) * $dmsgmax) < ($pcnt0 - $dmsgmax + 0)) {
    $opagno = $pageno + 1;
  }
#print qq(zz$opagno/$npagno<br>);
}

sub meidsp {
  s/(\r\n|\r|\n)//gm;
  s/\\t/　　/g;
  s/\\yen/\\/g;

  $selsw0 = 0;
  logset($_); #ログメッセージのセット
  if (",srcdsp," =~ ",$act,") {
    &srcchk($_);
  } else {
    if ((length $parent) > 0) {
      if ((@val[0] == $parent) || (@val[1] == $parent)) { $selsw0 = 1; }
    } elsif ((length $child) > 0) {
      if (@val[0] == $child) { $selsw0 = 1; }
    } elsif ((length $savresno) > 0) {
      if ((@val[0] == $savresno) || (@val[1] == $savresno)) { $selsw0 = 1; }
    }else {
      $selsw0 = 1;
    }
  }

  if ($selsw0 != 0) { #検索条件で表示の開始
#コメントをデコード竏停・竏驤
#    @val[4]  = decode(@val[4]);
#    @val[4] =~ s/(\r\n|\r|\n)//gm;
#    @val[4] =~ s/\\t/　　/g;
#    @val[4] =~ s/\\yen/\\/g;
    $msgno     = @val[0];
    $resno     = @val[1];
    $date     = @val[2];
    $subj     = @val[3];
    $comment  = @val[4];
    $tcolor   = @val[5];
    $icon     = @val[6];
    $name     = @val[7];
    $email     = @val[8];
    $url       = @val[9];
    $banner    = @val[10];
#    $pwd       = @val[11];
    $ctrlsw   = @val[12];
    $brow     = @val[13];
    $rmhost     = @val[14];
    $addr     = @val[15];
    @wrk = split(/\//, $ctrlsw);
    $ctrl1   = $wrk[0];
    $ctrl2   = $wrk[1];
    $ctrl3   = $wrk[2];
    $ctrl4   = $wrk[3];
    $ctrl5   = $wrk[4];
    $ctrl6   = $wrk[5];
    $clkcnt = $wrk[6];
    if ($resno eq "") {
      if ($scnt0 != 0){
        $sknsep = "mend"; #メッセージエンド部
        &skindsp; #スキンの表示
      }
      $sknsep = "main"; #親メッセージ部
    } else {
      $sknsep = "msub"; #子メッセージ部
    }
    &skindsp; #スキンの表示
  } #検索条件で表示の終了
}

sub srcchk {
  my($line) = @_;
  $selsw0=1;
}

sub skindsp {
  if (("$sknnam/" !~ "htm") && ("$sknnam/" !~ "html")){
    $sknnam  = "";
  }
#htmファイルを表示する
  open(FILE, "<$sknnam") || werror("スキンがオープンできません。(skindsp)",$sknnam); #htmファイルの読み込み

#セパレータまで読み飛ばす
  if (",,skin," !~ ",$sknsep,") {
    while(<FILE>){
      next if /^$/;
      $_ = henkan($_);
      if (/(.*)<!--$sknsep-->(.*)/i) { 
        print qq(\n$2\n);
        last;
      }
    } #読み飛ばし終了
  }

  if (",,skin," =~ ",$sknsep,") {
    print qq(<!--skin board by atom(http://atom.hostmycgi5.com/)-->\n);
  }
  if (",main,msub," =~ ",$sknsep,") { #メッセージ関係のとき
    print qq(<a name=\"$msgno\"></a>\n);
  }
  while(<FILE>){
    next if /^$/;
    $_ = henkan($_);
    $selsw0 = 0;
#スキンの区切りマークかどうかをチェック
    if (/(.*)<!--(\w*)-->(.*)/i) { 
      $str0 = $2;
      if (",$sknsep0," =~ $str0) { $selsw0 = 1; }
    }
#print "aa$selsw0 $_<br>";
    if ($selsw0 == 1) { 
      $sav1 =$1;
      $sav1 =~ s/#\\oldjmp\\#/#oldjmp#/igm;
      $sav1 =~ s/#\\olddsp\\#/#olddsp#/igm;
      print qq(\n$sav1\n);
      last;
    }else{
      if (/(.*)#oldjmp#(.*)/i) { 
        print qq($1\n);
        &oldjmp;
        print qq($2);
      } elsif (/(.*)#olddsp#(.*)/i) { 
        print qq($1\n);
        &olddsp;
        print qq($2);
      } elsif (/(.*)<!--\#include virtual="(.*)"-->(.*)/) { #指定ファイルのインサート
        $sav3 = $3;
        print qq($1\n);
        &filins($2);
        print qq($sav3);
      } else {
        s/#\\oldjmp\\#/#oldjmp#/igm;
        s/#\\olddsp\\#/#olddsp#/igm;
        print;
      }
    }
  } #読み込み終了
  close(FILE);

#新規以外の入力フォームの目印
  if (($sknsep =~ "form") && (",newexe," !~ ",$savact,")) {
    print qq(<A name="form_in"></A>\n);
  }
#HEAD部の表示
  if ($sknsep =~ "skin") { #ボディ部の時
    if (-e "$hednam") {
      open(FILE, "<$hednam");
      while(<FILE>){
        print;
      }
      close(FILE);
    }else {
#      werror("$hednamがありません。");
    }
  }
#foot部の表示
  if ($sknsep =~ "tail") { #フッター部の時
    if (-e "$fotnam") {
      open(FILE, "<$fotnam");
      while(<FILE>){
        print;
      }
      close(FILE);
    }else {
#      werror("$fotnamがありません。");
    }
  }
}

sub filins{
  my($filnam) = @_[0];
#メニュー文書の表示
  open(HTM, "<$filnam") || &werror("指定されたファイルが存在しません",$filnam);
    while(<HTM>){
      $_ = henkan($_);
      s/^#(.*)/<font color=green>#$1<\/font>/; ##以降の文字色をグリーンする
      if (/(.*)<!--gcounter-->(.*)/) { #グラフィックカウンタの表示
        print qq($1\n);
        &gcounter;
        print qq($2);
      } else {
        print qq($_);
      }
#      print qq(<br>);
    }
  close(HTM);
}

sub henkan{
#定義文字を変換する
  my(@oldlst) = split(/\t/,$extlst);
  shift @oldlst;
  my($str0) = @_;
  my($omax);
  if ($autlog =~ $bbslog) { #自動連絡メッセージの場合
    $dmsgno  = $val[11]; #pwd
  } else {
    $dmsgno = $msgno;
  }
  $dresno = $resno;
  if (($dresno ne "") && ($dmsgno > $dresno)) {
    $wrk = $dmsgno;
    $dmsgno = $dresno;
    $dresno = $wrk;
  }
  $dresmsg = $dresno;
  $dact = "";
  if ($dresmsg eq "") { $dresmsg = $dmsgno; }
  if ($act eq "tree") { $dact = $act; }

  $qicon = quotemeta($icon);
  $qsort = quotemeta($sort);
  $str0 =~ s/#accdir#/$accdir/igm;
  $str0 =~ s/#bbsdir#/$bbsdir/igm;
  $str0 =~ s/#cgidir#/$cgidir/igm;
  $str0 =~ s/#skndir#/$skndir/igm;
  $str0 =~ s/#imgdir#/$imgdir/igm;
  $str0 =~ s/#cginam#/$cginam0/igm;
  $str0 =~ s/#cfgnam#/$cfgnam/igm;
  $str0 =~ s/#lognam#/$lognam/igm;
  $str0 =~ s/#logext#/$logext/igm;
  $str0 =~ s/#pageno#/$pageno/igm;
  $str0 =~ s/#topadr#/$topadr/igm;
  $str0 =~ s/#sbment#/$sbment/igm;
  $str0 =~ s/#zcount#/$zcount/igm;
  $str0 =~ s/#count#/$count/igm;
  $str0 =~ s/#msgno#/$msgno/igm;
  $str0 =~ s/#resno#/$resno/igm;
  $str0 =~ s/#act#/$act/igm;
  if ($url eq "") {
#KIN用修正追加↓
    $str0 =~ s/\[<a\shref=\"#url#\"([^>]*)>WEB<\/a>\]//igm;
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>([^<]*)<\/a>//igm;
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>/<a name="#"$1>/igm;
    $str0 =~ s/<img\ssrc=\"#url#\"([^>]*)>//igm;
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>#homnam#/<a name="#"$1>/igm;
    $str0 =~ s/#url#//igm;
  } else {
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>([^<]*)<\/a>/<a href="http:\/\/$url"$1>$2<\/a>/igm;
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>/<a href="http:\/\/$url"$1>/igm;
    $str0 =~ s/<img\ssrc=\"#url#\"([^>]*)>/<img src="http:\/\/$url"$1>/igm;
    $str0 =~ s/<a\shref=\"#url#\"([^>]*)>#homnam#/<a href="http:\/\/$url"$1><img src="$homnam">/igm;
    $str0 =~ s/#url#/$url/igm;
  }
  $str0 =~ s/#homnam#/$homnam/igm;
  if ($email eq "") {
    $str0 =~ s/<a\shref=\"mailto:#email#\"([^>]*)>([^#]*)#name#([^<]*)<\/a>/$2$name$3/igm;
    $str0 =~ s/<a\shref=\"mailto:#email#\"([^>]*)>([^<]*)<\/a>//igm;
    $str0 =~ s/<a\shref=\"mailto:#email#\"([^>]*)>/<a name="#"$1>/igm;
    $str0 =~ s/#email#//igm;
  } else {
    $str0 =~ s/<a\shref=\"mailto:#email#\"([^>]*)>([^<]*)<\/a>/<a href="mailto:$email"$1>$2<\/a>/igm;
    $str0 =~ s/<a\shref=\"mailto:#email#\"([^>]*)>/<a href="mailto:$email"$1>/igm;
    $str0 =~ s/#email#/$email/igm;
  }
  $str0 =~ s/#title#/$title/igm;
  $str0 =~ s/#subj#/$subj/igm;
  $str0 =~ s/#name#/$name/igm;
  $str0 =~ s/#date#/$date/igm;
  $str0 =~ s/#tcolor#/$tcolor/igm;
  $str0 =~ s/#tcck$tcolor#\"/$tcolor" checked/igm;
  $str0 =~ s/#tcck(\w*)#\"/$1\"/igm;
  $str0 =~ s/#tcsl$tcolor#\"/$tcolor" selected/igm;
  $str0 =~ s/#tcsl(\w*)#\"/$1\"/igm;
  $str0 =~ s/#icon#/$icon/igm;
  $str0 =~ s/#icck$qicon#\"/$icon" checked/igm;
  $str0 =~ s/#icck(.*)#\"/$1"/igm;
  $str0 =~ s/#icsl$qicon#\"/$icon" selected/igm;
  $str0 =~ s/#icsl(.*)#\"/$1"/igm;
  $str0 =~ s/#sort#/$sort/igm;
  $str0 =~ s/#stck$qsort#\"/$sort" checked/igm;
  $str0 =~ s/#stck(.*)#\"/$1"/igm;
  $str0 =~ s/#stsl$qsort#\"/$sort" selected/igm;
  $str0 =~ s/#stsl(.*)#\"/$1"/igm;
  $str0 =~ s/#pwd#/$pwd/igm;
  for ($i = 1; $i <= 6; $i++) {
    $wrk = eval{"$ctrl$i"};
    $str0 =~ s/#ctrl$i#/$wrk/igm;
  }
  $str0 =~ s/#clkcnt#/$clkcnt/igm;
  $str0 =~ s/#order#/$order/igm;
  $str0 =~ s/#host#/$host/igm;
  $str0 =~ s/#addr#/$addr/igm;
  $str0 =~ s/#rmhost#/$rmhost/igm;
  $str0 =~ s/#savresno#/$savresno/igm;
  $str0 =~ s/#sbhelp#/sbhelp.shtm/igm;
if ($lognam eq $bbslog) { 
  $str0 =~ s/#msgdsp#/$cginam0?$cfgchg/igm;
  $str0 =~ s/#srcinp#/$cginam0?$cfgchg&act=srcinp/igm;
  $str0 =~ s/#newinp#/$cginam0?$cfgchg&act=newinp#form_in/igm;
  $str0 =~ s/#resinp#/$cginam0?$cfgchg&act=resinp&resno=$dresmsg&parent=$dmsgno#form_in/igm;
  if (($adname =~ "atom") && (",cgibrd," =~ ",$cfgnam,")){
    $str0 =~ s/#delinp#/$cginam0?$cfgchg&act=delinp&resno=$msgno&parent=$msgno#form_in/igm;
  } else {
    $str0 =~ s/#delinp#/$cginam0?$cfgchg&act=delinp&resno=$dresmsg&parent=$dmsgno#form_in/igm;
  }
} else {
  $str0 =~ s/#msgdsp#/$cginam0?$cfgchg&$logchg/igm;
  $str0 =~ s/#srcinp#/$cginam0?$cfgchg&$logchg&act=srcinp/igm;
  $str0 =~ s/<a\shref=\"#newinp#\"([^>]*)>/<a name=\"#\"$1>/igm;
  $str0 =~ s/<a\shref=\"#resinp#\"([^>]*)>/<a name=\"#\"$1>/igm;
  $str0 =~ s/<a\shref=\"#delinp#\"([^>]*)>/<a name=\"#\"$1>/igm;
}
  $str0 =~ s/#repchk#/$cginam0?$cfgchg&act=repchk&resno=$dresno/igm;
  $str0 =~ s/#delchk#/$cginam0?$cfgchg&act=delchk&resno=$dresno/igm;
  $str0 =~ s/#mntchk#/$cginam0?$cfgchg&act=mntchk/igm;

  if ($brow eq "") { #ブラウザの表示
    $str0 =~ s/<a\shref=\"#brow#\"([^>]*)>/<a name="#"$1>/igm;
    $str0 =~ s/#brow#//igm;
  } else {
    $str0 =~ s/<a\shref=\"#brow#\"([^>]*)>/<a href="javascript:alert('$brow');" title="$brow"$1>/igm;
    $str0 =~ s/#brow#/$brow/igm;
  }
  if ($banner eq "") { #バナーの表示
    $str0 =~ s/<a\shref=\"#banner#\"([^>]*)>/<a name="#"$1>/igm;
    $str0 =~ s/<img\ssrc=\"#banner#\"([^>]*)>//igm;
    $str0 =~ s/#banner#//igm;
  } elsif (substr($banner,0,1) eq "/") { #バナーの表示
    $str0 =~ s/<a\shref=\"#banner#\"([^>]*)>/<a href="$banner"$1>/igm;
    $str0 =~ s/<img\ssrc=\"#banner#\"([^>]*)>/<img src="$banner"$1>/igm;
    $str0 =~ s/#banner#/$banner/igm;
  } else {
    $str0 =~ s/<a\shref=\"#banner#\"([^>]*)>/<a href="http:\/\/$banner"$1>/igm;
    $str0 =~ s/<img\ssrc=\"#banner#\"([^>]*)>/<img src="http:\/\/$banner"$1>/igm;
    $str0 =~ s/#banner#/$banner/igm;
  }
  if ($npagno eq "") { #前頁の表示
    $str0 =~ s/<a\shref=\"#newpag#\"([^>]*)>/<a name="#"$1>/igm;
  } else {
      $str0 =~ s/<a\shref=\"#newpag#\"([^>]*)>/<a href="$cginam0?$cfgchg&logext=$logext&pageno=$npagno"$1>/igm;
  }
  if ($opagno eq "") { #次頁の表示
    $str0 =~ s/<a\shref=\"#oldpag#\"([^>]*)>/<a name="#"$1>/igm;
  } else {
    $str0 =~ s/<a\shref=\"#oldpag#\"([^>]*)>/<a href="$cginam0?$cfgchg&logext=$logext&pageno=$opagno"$1>/igm;
  }
  if (($nlogno eq "") && ($extlst ne "") && ($logext eq $oldlst[0])) { #新しい過去ログ表示
    $str0 =~ s/<a\shref=\"#newlog#\"([^>]*)>/<a href="$cginam0?$cfgchg"$1>/igm;
  } elsif ($nlogno eq "") {
    $str0 =~ s/<a\shref=\"#newlog#\"([^>]*)>/<a name="#"$1>/igm;
  } else {
    $str0 =~ s/<a\shref=\"#newlog#\"([^>]*)>/<a href="$cginam0?$cfgchg&logext=$nlogno"$1>/igm;
  }
  if ($ologno eq "") { #古い過去ログ表示
    $str0 =~ s/<a\shref=\"#oldlog#\"([^>]*)>/<a name="#"$1>/igm;
  } else {
    $str0 =~ s/<a\shref=\"#oldlog#\"([^>]*)>/<a href="$cginam0?$cfgchg&logext=$ologno"$1>/igm;
  }

  if (($adname =~ "atom") && (",cgibrd," =~ ",$cfgnam,")){
    $str0 =~ s/<a\shref=\"#parent#\"([^>]*)>/<a href="$url&parent=$dmsgno#form_in"$1>/igm;
  }else{
    $str0 =~ s/<a\shref=\"#parent#\"([^>]*)>/<a href="$cginam0?$cfgchg&parent=$dmsgno#form_in"$1>/igm;
  }
  if ($dresno eq "") {
      $str0 =~ s/<a\shref=\"#child#\"([^>]*)>/<a name="#"$1>/igm;
      $str0 =~ s/#child#//igm;
  } else {
    if (($adname =~ "atom") && (",cgibrd," =~ ",$cfgnam,")){
      $str0 =~ s/<a\shref=\"#child#\"([^>]*)>/<a href="$url&parent=$dresno#form_in"$1>/igm;
    }else{
      $str0 =~ s/<a\shref=\"#child#\"([^>]*)>/<a href="$cginam0?$cfgchg&parent=$dresno#form_in"$1>/igm;
    }
  }
  $str0 =~ s/#parent#/$parent/igm;
  $str0 =~ s/#child#/$child/igm;
  if ($jump eq "") {
    $str0 =~ s/\s#bjump#//igm;
  } else {
    $str0 =~ s/#bjump#/onload="setTimeout(&quot;location.href='#$jump'&quot;,100)"/igm;
  }
  $str0 =~ s/<a\shref=\"#jump#\"([^>]*)>/<a href="$url?jump=$jump"$1>/igm;
  $str0 =~ s/#jump#/$jump/igm;

#  $str0 =~ s/&&/&/igm;
#  $str0 =~ s/\?&/?/igm;
#  $str0 =~ s/($cginam0[\w\/.~!?=&:;%#|+-]+)\&+\"/$1\"/igm;
#  $str0 =~ s/($cginam0)\?\"/$1\"/igm;
#  $_ = $str0;
  while($str0 =~ s/(\?|&|cfgnam=|lognam=|logext=|pageno=|act=)\"/"/igm){}
  while($str0 =~ s/(cfgnam=&|lognam=&|logext=&|pageno=&|act=&)//igm){}
  while($str0 =~ s/(\?&)/?/igm){}
#  $str0 = $_;

  $comment =~ s/#oldjmp#/#\\oldjmp\\#/igm;
  $comment =~ s/#olddsp#/#\\olddsp\\#/igm;
  $str0 =~ s/#comment#/$comment/igm;

  return $str0;
}

sub logget{
#投稿メッセージを取得する
  open(FILE, "<$bbslog0") || werror("ログファイルがオープンできません。(logget)",$bbslog0);
  while (<FILE>){
    logset($_); #ログメッセージのセット
#コメントをデコード竏停・竏驤
    @val[4]  = decode(@val[4]);
    $selsw0 = 0;
    $dmsgno = @val[1];
    if ($dmsgno eq "") { $dmsgno = @val[0]; }
    if (($adname =~ "atom") && ($cfgnam =~ "cgibrd")) { $dmsgno = @val[0]; }
    if ($savresno == $dmsgno) { $selsw0 = 1; }
#print "$savresno/$dmsgno<br>";
    if ($selsw0 == 1) {
      if (",resinp," !~ ",$act,") { 
        $msgno = @val[0]; 
        $resno = @val[1];
      }
#      if (@val[1] ne ""){ $resno = @val[1]; }
#      $date     = @val[2];
      $subj     = @val[3];
      $comment  = @val[4];
      if (",resinp," !~ ",$act,") {
        $tcolor   = @val[5];
        $icon       = @val[6];
        $name     = @val[7];
        $email     = @val[8];
        $url       = @val[9];
        $banner    = @val[10];
        if (@val[11] eq $admpwd) {$pwd = @val[11];}
        if ($cokpwd eq $admpwd) {$pwd = @val[11];}
        $ctrlsw    = @val[12];
#        $brow      = @val[13];
        @wrk = split(/\//, $ctrlsw);
        $ctrl1   = $wrk[0];
        $ctrl2   = $wrk[1];
        $ctrl3   = $wrk[2];
        $ctrl4   = $wrk[3];
        $ctrl5   = $wrk[4];
        $ctrl6   = $wrk[5];
        $clkcnt = $wrk[6];
      }
      last;
    }
  }
  close(FILE);
#  $zcount = sprintf("%6.6d", $msgno);
#print "$msgno<br>";
#print "$resno<br>";
}

sub encode{
#メッセージ等をエンコードする
  local($_) = @_;
  s/<([^<]*)>/&quot_chk($1)/ge;
  s/&/&amp;/igm;
  s/</&lt;/igm;
  s/>/&gt;/igm;
  s/\t/\\t/igm;
#  s/\"/\\&quot;/igm;
  if ($tagtyp != 1) {
    s/((http|ftp|news|gopher)\:\/\/[\w\/.~!?=&:;%#|+-]+)/<a href=\"$1\" target=\"_blank\">$1<\/a>/igm;
  }
  s/(^|[^\x81-\x9F\xE0-\xFC])([\w.-]+@[\w.-]+)/$1<a href=\"mailto:$2\">$2<\/a>/igm;
  s/\\&quot;/&quot;/igm;
  s/(\r\n|\r|\n)/<br>/igm;
  s/\\/\\yen/igm;
  if ($tagtyp == 1) {
    while(s/&lt;(font|a)\s*([^&]*)&gt;([^&]*)&lt;\/\1&gt;/<$1 $2>$3<\/$1>/igm){}
    while(s/&lt;(img)\s*([^&]*)&gt;/<$1 $2>/igm){}
  }
  return $_;
}

sub quot_chk{
#ダブルクォートの閉じ忘れチェック
  local($_) = @_;
  if (tr/"/"/ %2){
    s/\s*$/"/;
  }
  return "<$_>";
}

sub decode{
#メッセージ等をデコードする
  my ($str0) = @_;
  $str0 =~ s/<br>/\r\n/igm;
  if ($tagtyp != 1) {
    $str0 =~ s/<\/a>//igm;
  }
  if ($tagtyp != 1) {
    $str0 =~ s/<a\shref=\"(http|ftp|news|gopher)\:\/\/[\w\/.~!?=&:;%#|+-]+\"\starget=\"_blank\">//igm;
    $str0 =~ s/<a\shref=\"[\w\/.~!?=&:;%#|+-]+\"\starget=\"_blank\">//igm;
    $str0 =~ s/<a\shref=\"[\w\/.~!?=&:;%#|+-]+\">//igm;
  }
  $str0 =~ s/<a\shref=\"mailto\:[[\w.-]+@[\w.-]+\">//igm;
  $str0 =~ s/\\t/\t/igm;
  $str0 =~ s/\\yen/\\/igm;
  return $str0;
}

sub inpchk {
#投稿禁止チェックのため追加
  my(@wrk);
#入力項目のチェック
  $errmsg = "";
  $url     =~ s/^http\:\/\///gm;
  $banner =~ s/^http\:\/\///gm;
  if (",delexe," !~ ",$act,") {
    if ((",$inpchk," =~ "subj") && ($subj eq "")) { $errmsg .= "タイトルが入力されてません。<br>"; }
    if ((",$inpchk," =~ "comment") && ($comment eq "")) { $errmsg .= "コメントが入力されてません。<br>"; }
    if ((",$inpchk," =~ "name") && ($name eq "")) { $errmsg .= "お名前が入力されてません。<br>"; }
    if ((",$inpchk," =~ "email") && ($email eq "")) { $errmsg .= "E-mailが入力されてません。<br>"; }
    if ((",$inpchk," =~ "url") && ($url eq "")) { $errmsg .= "ＵＲＬが入力されてません。<br>"; }
    if ((",$inpchk," =~ "banner") && ($banner eq "")) {
      if (",.bmp,.gif,.jpg,jpeg,.png," !~ substr($banner,-4,3)) {
        $errmsg .= "バナーは.bmp、.gif、.jpg、.jpeg、.pngを指定して下さい。<br>";
      }
    }
#投稿禁止チェック
    @wrk = split(/,/, $denyword);
    foreach (@wrk){
      if ($comment =~ "$_"){
        $errmsg .= "投稿禁止語句が含まれています。<br>";
      }
    }
  }
  if ($errmsg eq "") {
    if (!-e $bbslog0) {
      open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(inpchk)",$bbslog0);
      chmod(0666, $bbslog0) || werror("chmod error(inpchk)",$bbslog0);
      close(FILE);
    }
    open(FILE, "<$bbslog0") || werror("ログファイルがオープンできません。(inpchk)",$bbslog0);
      @logmsg = <FILE>;
    close(FILE);
  }

  $pcnt0 = 0; $movresno = "";
  foreach (@logmsg) {
    logset($_); #ログメッセージのセット
#コメントをデコード竏停・竏驤
    ($dcomment) = decode(@val[4]);
    $dcomment =~ s/&lt;/</g;
    $dcomment =~ s/&gt;/>/g;
    if (@val[1] eq ""){ $pcnt0++; } #親メッセージをカウント
    if (($msgmax ne "") && ($pcnt0 >= $msgmax) && ($movresno eq "")) { $movresno = $val[0]; }
    $dpwd = $pwd;
    if ($pwseed ne "") { $dpwd = crypt($pwd, $pwseed); }
    if (",newexe,resexe," =~ ",$act,") {
      if ((@val[7] eq $name) && (@val[3] eq $subj) && ($dcomment eq $comment)) {
        $errmsg .= "二重投稿になります。<br>";
      }
    } else {
      $selsw0 = 0;
      if (@val[1] eq "") {
        if ($savresno == @val[0]) { $selsw0 = 1; }
      } else {
        if ($savresno == @val[1]) { $selsw0 = 1; }
      }
#print "aa$selsw0 / $savresno / @val[0]-@val[1] / @val[11] / $pwd / $dpwd<br>";
      if ($selsw0 == 1) {
        if ((",$admpwd," !~ ",$pwd,") && (",$admpwd," !~ ",$dpwd,")) { #入力キーが管理者以外のとき
          if (($pwd ne @val[11]) && ($dpwd ne @val[11])) {  
            $errmsg .= "入力キーが違います。<br>";
#            $errmsg .= "@val[0]-@val[1] / @val[11] / $pwd / $dpwd<br>";
          }
        }
      }
    }
  }
  if ($errmsg eq "") {
    $denysw0 = 0;
    if (($denyname ne "") && (index(",$denyname,", ",$name,") >= 0)) { $denysw0 = 1; } #投稿拒否のチェック
    if (($allowkey ne "") && (",$allowkey," !~ ",$pwd,")) { $denysw0 = 1; } #入力許可のチェック
    if ($denysw0 == 0) {
      $savpwd = $pwd;
      $pwd = $dpwd;
      if (",newexe,resexe," =~ ",$act,"){
        if ((",newexe," =~ ",$act,") && ($movresno ne "")) { &oldmak_chk; }
        &bbscnt_up;
        if (",newexe," =~ ",$act,"){
          $msgno = $count;
          $resno = "";
        } else {
          $msgno = $parent;
          $resno = $count;
        }
        &newexe;
      } else {
        if ((",$adname," =~ ",atom,") && (",lnkbrd," =~ ",$cfgnam,") && (",21,22,23," !~ ",$dsptyp,") && (",delexe," !~ ",$act,")){
          $msgno = $parent;
          &newexe; #入換えのときに最初に移動する
        } else {
          &repexe;
        }
      }
      $pwd = $savpwd;
    } else {
      $url   =~ s/^http\:\/\///gm;
      $addr   =~ s/^http\:\/\///gm;
    }
  } else {
    &errdsp;
  }

  $subj = "";
  $comment = "";
  if (",newexe," =~ ",$act,"){
    $msgno = "";
    $resno = "";
    $parent = "";
    $savresno = "";
  }
}

sub newexe{
#新しいメッセージの追加
#コメントをエンコード竏停・竏驤
  ($subj) = encode($subj);
  ($comment) = encode($comment);
  $url    =~ s/^http\:\/\///gm;
  $banner   =~ s/^http\:\/\///gm;

  $new_msg = bbslog_mak(); #投稿メッセージの生成

  if (",newexe," =~ ",$act,"){
#新しい記事の追加処理
    if (",23," =~ ",$dsptyp,") {
      push (@logmsg, $new_msg); #新規メッセージを最後に追加
    } else {
      unshift (@logmsg, $new_msg); #新規メッセージを最初に追加
    }
#ログファイルを書き換え
    open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(newexe)",$bbslog0);
    print FILE @logmsg;
    close(FILE);
  } else {
    if (",21,22,23," =~ ",$dsptyp,") {
      &resexea;
    } else {
      &resexe;
    }
  }
#  exit(0); #テスト用

  if (($bbslog0 ne "") && ($autlog !~ $bbslog)) { &msgput2; } #自動連絡メッセージの書き込み
  if (($mailpr ne "") && ($mailad ne "")) { &sendmail; } #連絡メール送信
}

sub resexe{
#レス記事の追加処理
#レスがあると最初に移動する
  @oldmsg = ();
  foreach (@logmsg) {
    @val = split(/\t/);
    if (@val[0] == $parent || @val[1] == $parent) {
      if ((",$adname," !~ ",atom,") || (",lnkbrd," !~ ",$cfgnam,")){
        push(@newmsg, $_);
      }
    } else {
      push(@oldmsg, $_);
    }
  }
  push(@newmsg, $new_msg);

#ログファイルを書き換え
    open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(resexe)",$bbslog0);
    print FILE @newmsg;
    print FILE @oldmsg;
    close(FILE);
}

sub resexea{
#レス記事の追加処理
#レスがあっても移動しない
  $midx = -1;
  $mcnt = 1;
  foreach (@logmsg) {
    @val = split(/\t/);
    if ($midx == -1) {
      if ((@val[0] == $parent) || (@val[1] == $parent)) { $midx = $mcnt; }
    } elsif (@val[0] == $parent) {
        $midx = $mcnt;
    } else {
        last;
    }
    $mcnt++;
  }
  splice(@logmsg, $midx, 0, $new_msg);
#print "@logmsg";

#ログファイルを書き換え
    open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(resexea)",$bbslog0);
    print FILE @logmsg;
    close(FILE);
}

sub repexe{
#投稿メッセージの削除
  &refget; #refererなどの取得

#コメントをエンコード竏停・竏驤
  ($subj) = encode($subj);
  ($comment) = encode($comment);
  $url    =~ s/^http\:\/\///gm;
  $banner   =~ s/^http\:\/\///gm;

  $msgno = $parent;
  if ($parent eq $resno) { $resno = ""; }
  $new_msg = bbslog_mak(); #投稿メッセージの生成

  open(FILE, "<$bbslog0");
    @logmsg = <FILE>;
  close(FILE);
  foreach (@logmsg) {
    @val = split(/\t/);
    $selsw0 = 0;
    if ($savresno ne "") {
      if (($savresno == @val[0]) || ($savresno == @val[1])) { $selsw0 = 1; }
    }
    if ($selsw0 == 0) {  push(@newmsg, $_);  }
  }

#ログファイルを書き換え
  open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(repexe)",$bbslog0);
  print FILE @newmsg;
  close(FILE);
  $resno = ""; $savresno = "";
}

sub sendmail{
}

sub msgput2{
}

sub olddsp{
#過去ログ表示のためのフォーム
#  &oldlst_get; #過去ログの拡張子を取得
  local(@val) = split(/\t/,$namlst);
  my(@oldlst) = split(/\t/,$extlst);
  my($oldmax) = scalar @val;

  print qq(<SELECT name="logext">\n);
  for ($i = 0; $i < $oldmax; $i++) {
    print qq(  <OPTION value="$oldlst[$i]" );
    if ($logext eq $oldlst[$i]) { print qq(selected); }
    print qq(>$val[$i]</OPTION>\n);
  }
  print qq(</SELECT>\n);
}

sub oldjmp{
#過去ログ表示のためのフォーム（自動ジャンプ）
#  &oldlst_get; #過去ログの拡張子を取得
  local(@val) = split(/\t/,$namlst);
  my(@oldlst) = split(/\t/,$extlst);
  my($oldmax) = scalar @val;

  my($command) = "$cginam0?$cfgchg&lognam=$oldlog";
  $command =~ s/\?&/?/igm;
  $command =~ s/($cginam0[\w\/.~!?=&:;%#|+-]+)\&+\"/$1\"/igm;
  $command =~ s/($cginam0)\?+\"/$1\"/igm;

  print qq(<SELECT onchange="location=this.options[this.selectedIndex].value">\n);
  print qq(  <OPTION value="$cginam0?$cfgchg" );
  if ($bbslog0 eq "") { print qq(selected); }
  print qq(></OPTION>\n);

  for ($i = 1; $i < $oldmax; $i++) {
    print qq(  <OPTION value="$cginam0?$cfgchg&logext=$oldlst[$i]" );
    if ($bbslog0 =~ "$oldlog.$oldlst[$i]") { print qq(selected); }
    print qq(>$val[$i]</OPTION>\n);
  }
  print qq(</SELECT>\n);
}

sub oldlst_get{
  if ($oldlog eq "") {return(0);}
#過去ログの拡張子を取得する($extlst,$namlst,$oext)
  my(@oldlst,@files) = ();
  if ($oldext eq ""){
    @files = glob("$bbsdir/$oldlog.*");
  } else {
    @files = split(/,/,"$oldext");
  }
  foreach (sort {$b cmp $a} @files){ #降順に並べ替え
#print $_."<br>,".substr($_,-4,4).",<br>";
    if (",.cnt,.log,.cfg,.cgi,.lck,.htm,html,.sht,.lst," !~ (",".substr($_,-4,4).",")){
      s/$bbsdir\/$oldlog\.//;
      push @oldlst, $_;
    }
  }
  $extlst = ""; #過去ログの拡張子を記述
  $namlst = ""; #過去ログの表示名を記述
  foreach $logext (@oldlst){
    $bbslog2 = "$bbsdir/$oldlog.$logext"; #過去ログのファイル名
    open(OLD, "<$bbslog2") || werror("過去ログファイルがオープンできません。(oldlst_get)",$bbslog2); #過去ログファイルを開く
    $logmin = 0; $logmax = 0;
    while (<OLD>) {
      @val = split(/\t/);
      $dmsgno = $val[1];
      if ($dmsgno eq "") { $dmsgno = $val[0]; }
      if ($logmin == 0 || $dmsgno < $logmin) { $logmin = $dmsgno; }
      if ($logmax == 0 || $dmsgno > $logmax) { $logmax = $dmsgno; }
    }
    close(OLD);
#print qq(aa$logext<br>);
    $extlst .= "\t$logext";
    $namlst .= "\t$logext No.$logmax-No.$logmin";
  }
#  print qq($extlst<br>);
  $ologno = "";$nlogno = "";
  if ($extlst ne "") {
    $_ = $lognam;
    if (/^.*\.(.*)/) {
      @oldlst = split(/\t/,$extlst);
      for ($i = 0; $i <= $#oldlst; $i++) {
        if ($1 eq $oldlst[$i]) {
          $ologno = $oldlst[$i + 1];
          $nlogno = $oldlst[$i - 1];
          last;
        }
#print qq(aa$oldlst[$i]<br>);
      }
    }
    if ($ologno eq "") {
      if ($1 ne $oldlst[$#oldlst]) { $ologno = $oldlst[1]; }
    }
#print qq(zz$opag<br>);
  }
}

sub oldmak_chk{
  my(@oldlst) = split(/\t/,$extlst);
  shift @oldlst;
  $savlogext = $logext;
  $logext = sprintf("%3.3d", $oldlst[0]); #新規作成のログNoセット

  my($oldnam) = "$bbsdir/$oldlog.$logext";
  $pcnt0 = 0;
  if (-e $oldnam) {
    open(FILE, "<$oldnam") || werror("過去ログがオープンできません。(oldmak_chk)",$oldnam);
      my(@oldmsg) = <FILE>;
    close(FILE);
    foreach (@oldmsg) {
      @val = split(/\t/);
      if (@val[1] eq ""){ $pcnt0++; } #親メッセージをカウント
    }
  }

  if ($pcnt0 >= $omsgmax) {
    $mcnt = scalar @oldlst;
    if ($mcnt >= $olfmax) {
      $locknam = "loglock.lck";
      $locksw0 = 1;
      for ($i = 0; $i < 5; $i++){
        open(FILE, "<$locknam") || werror("ロックファイルがオープンできません。(oldmak_chk)",$locknam);
        $locksw0 = <FILE>;
        close(FILE);
        if ($locksw0 ne "1") {   last;  }
        sleep(1);
      }
      if ($locksw0 ne "1") {
#過去ログメッセージのスライド
        open(FILE, ">$locknam") || werror("ロックファイルが作成できません。(oldmak_chk)",$locknam);
        print FILE "1";
        close(FILE);
        for ($midx = $mcnt - 1; $midx > 0; $midx--) {
          $extno  = $oldlst[$midx - 1];
          $wrkext = $oldlst[$midx];
          $bbslog1 = "$bbsdir/$oldlog.$extno"; #読み込みのログファイル名
          $bbslog2 = "$bbsdir/$oldlog.$wrkext"; #書き込みのログファイル名
#ログファイルの読み込み
          open(FILE, "<$bbslog1") || werror("過去ログがオープンできません。(oldmak_chk)",$bbslog1);
            @oldmsg = <FILE>;
          close(FILE);
#ログファイルの書き込み
          open(FILE, ">$bbslog2") || werror("過去ログに書き込みできません。(oldmak_chk)",$bbslog2);
          print FILE @oldmsg;
          close(FILE);
        }
        $extno = sprintf("%3.3d", $logext);
        $bbslog2 = "$bbsdir/$oldlog.$extno"; #過去ログのファイル名
        open(FILE, ">$bbslog2") || werror("過去ログに書き込みできません。(oldmak_chk)",$bbslog2);
        close(FILE);
        open(FILE, ">$locknam") || werror("ロックファイルが作成できません。(oldmak_chk)",$locknam);
        close(FILE);
      } else {
        werror("過去ログファイルがロック中です。(oldmak_chk)",$locknam);
      }
    } else {
      $logext = sprintf("%3.3d", $oldlst[0] + 1); #新規作成のログNoセット
      $extno = sprintf("%3.3d", $logext);
    }
    $bbslog2 = "$bbsdir/$oldlog.$extno"; #過去ログのファイル名
    if (!-e $bbslog2) {
      open(FILE, ">$bbslog2") || werror("ログファイルに書き込みできません。(oldmak_chk)",$bbslog2);
      chmod(0666, $bbslog2) || werror("chmod error(oldmak_chk)",$bbslog2);
      close(FILE);
    }
  }

  if ($locksw0 ne "1") { &movold; }
  &oldlst_get; #最新の過去ログの拡張子を取得
  $logext = $savlogext;
}

sub errdsp {
#エラー表示して終了
#  local($file) = @_; #引数を取得する
  $sknsep = "head"; #ヘッダ部のファイル名
  &skindsp; #スキンの表示
#ヒアドキュメントで表示
print << "END_OF_DOC91";
<center>
<br>
<br>
<h4><br>
<font color="red">
「戻る」ボタンをクリックして<br>
以下の項目を再度入力してください。
</font>
</h4>
$errmsg
<br>
<INPUT type="button" value="戻　る" onclick="history.go(-1)">
<br><br>
</CENTER>
END_OF_DOC91

  $sknsep = "tail"; #フッタ部のファイル名
  &skindsp; #スキンの表示
  exit(0);
}

#====================
#--- 管理画面処理 ---
#====================

sub mntchk{
#管理画面用パスワードチェック
  $sknsep = "tail"; #フッタ部のファイル名
  &skindsp; #スキンの表示
}

sub mntdsp {
#管理者画面の表示
  $dpwd = $pwd; $errmsg = "";
  if ($pwseed ne "") { $dpwd = crypt($pwd, $pwseed); }
  if ((",$admpwd," !~ ",$pwd,") && (",$admpwd," !~ ",$dpwd,")) { #入力キーが管理者以外のとき
    $errmsg .= "入力キーが違います。<br>";
  }
  if ($errmsg ne "") { 
#print "$sknnam<br>";
    $sknsep = "skin"; #ボディ部の区切り名
    &skindsp; #スキンの表示
    &errdsp; exit(0);
  }

#ＢＢＳカウンタの取得
  if (",repcnt,alldel," !~ $act) { 
    &bbscnt_get;
  } else {
    $count = $resno;
  }

  &oldlst_get;
#  $savact = $act;
#  $act = "mntdsp";
  $sknnam = "$sbment"; #管理者画面のファイル名
  &skindsp; #スキンの表示
#  $act = $savact;

  if ($act eq "mntdsp") { 
    $sknsep = "form"; #入力フォーム部のファイル名
    &skindsp; #スキンの表示
  } else {
    print qq(<center>);
    if ($act eq "repcnt") { &repcnt; } #記事No用ＢＢＳカウンタの訂正
    if ($act eq "alldel") { &alldel; } #投稿メッセージの全削除
    if ($act eq "msgdel") { &msgdel; } #投稿メッセージの一括削除
    if ($act eq "movold") { $movresno = $resno; &movold; } #過去ログメッセージに移動
    if ($act eq "oldclr") { &oldlog_clr; } #過去ログファイルのクリア
    if ($act eq "olddel") { &oldlog_del; } #過去ログファイルの削除
    print qq(</center>);
  }
  
  $sknsep = "tail"; #フッタ部のファイル名
  &skindsp; #スキンの表示
}

sub repcnt{
#記事No用ＢＢＳカウンタの訂正
  open(FILE,">$bbscnt0") || werror("ＢＢＳカウンタに書き込みできません。(repcnt)",$bbscnt0); #ＢＢＳカウンタファイルを開く
  print FILE $resno; #ＢＢＳカウンタ値を記録する
  close(FILE); #ＢＢＳカウンタファイルを閉じる

#ヒアドキュメントで表示
print << "END_OF_DOC81";
<h5><font color="red">ＢＢＳカウンタの訂正が終了しました。</font></h5>
$act
END_OF_DOC81
}

sub alldel{
#投稿メッセージの一括削除
  if ($resno eq "") {
    $count = $resno;
    open(FILE,">$bbslog0") || werror("ログファイルに書き込みできません。(alldel)",$bbslog0);
    close(FILE); #ログファイルを閉じる
    open(FILE,">$bbscnt0") || werror("ＢＢＳカウンタに書き込みできません。(alldel)",$bbscnt0); #ＢＢＳカウンタファイルを開く
    close(FILE); #ＢＢＳカウンタファイルを閉じる

#ヒアドキュメントで表示
print << "END_OF_DOC82";
<h5><font color="red">すべてのログファイルを削除しました。</font></h5>
$act
END_OF_DOC82
  } else {
    &msgdel;
  }
}

sub msgdel {
#ログメッセージの一括削除
  if (!-e $bbslog0) {
    open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(msgdel)",$bbslog0);
    chmod(0666, $bbslog0) || werror("chmod error(msgdel)",$bbslog0);
    close(FILE);
  }
  open(FILE, "<$bbslog0") || werror("ログファイルがオープンできません。(msgdel)",$bbslog0);
    @logmsg = <FILE>;
  close(FILE);
  $selsw0 = 0;
  foreach (@logmsg) {
    @val = split(/\t/);
    if ($val[0] == $resno || $val[1] == $resno) { $selsw0 = 1; }
    if ($selsw0 == 0) {
      push(@newmsg, $_);
    } else {
      push(@wrkmsg, $_);
    }
  }

#ログファイルを書き換え
  open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(msgdel)",$bbslog0);
  print FILE @newmsg;
  close(FILE);
  $tkensu = scalar @logmsg;
  $nkensu = scalar @newmsg;
  $okensu = $tkensu - $nkensu;

#ヒアドキュメントで表示
print << "END_OF_DOC83";
処理対象件数： $okensu 件<br>
最新ログ件数： $nkensu 件<br><br>
<h5><font color="red">指定されたメッセージログの削除終了！！</font></h5>
$act
END_OF_DOC83
}

sub movold{
  local(@oldmsg,@newmsg,@wrkmsg) = ();
  $extno = sprintf("%3.3d", $logext);
  $bbslog2 = "$bbsdir/$oldlog.$extno"; #過去ログのファイル名
  $bbslog0 = "$bbsdir/$bbslog"; #現在ログのファイル名

#過去ログファイルの読み込み
  open(FILE, "<$bbslog2") || werror("過去ログがオープンできません。(movold)",$bbslog2);
    @oldmsg = <FILE>;
  close(FILE);

#現在のログファイルの読み込み
  open(FILE, "<$bbslog0") || werror("ログファイルがオープンできません。(movold)",$bbslog0);
    @logmsg = <FILE>;
  close(FILE);
  $selsw0 = 0;
  foreach (@logmsg) {
    @val = split(/\t/);
    if ($val[0] == $movresno || $val[1] == $movresno) { $selsw0 = 1; }
    if ($selsw0 == 0) {
      push(@newmsg, $_);
    } else {
      push(@wrkmsg, $_);
#      push(@oldmsg, $_);
    }
  }

#過去ログファイルを作成
  open(FILE, ">$bbslog2") || werror("過去ログに書き込みできません。(movold)",$bbslog2);
  print FILE @wrkmsg;
  print FILE @oldmsg;
  close(FILE);
#現在のログファイルを書き換え
  open(FILE, ">$bbslog0") || werror("ログファイルに書き込みできません。(movold)",$bbslog0);
  print FILE @newmsg;
  close(FILE);
  @logmsg = @newmsg;
  if ($act ne "movold") { return(0); }

  $tkensu = scalar @logmsg;
  $nkensu = scalar @newmsg;
  $wkensu = scalar @wrkmsg;
#  $okensu = scalar @oldmsg;

#ヒアドキュメントで表示
print << "END_OF_DOC84";
処理対象件数： $tkensu 件<br><br>
過去ログ件数： $okensu 件<br>
最新ログ件数： $nkensu 件<br><br>
<br>
<h5><font color="red">
過去ログファイルの作成完了！！<br>
</font></h5>
$act
END_OF_DOC84
}

sub oldlog_clr{
#過去ログのクリア
  my($filnam) = "$bbsdir/$oldlog.$logext";
  if (!-e $filnam) { werror("該当ファイルがありません。(oldlog_clr)",$filnam); }
  open(FILE, ">$filnam") || werror("過去ログがオープンできません。(oldlog_clr)",$bbslog2);
  close(FILE);

  print "<BR><BR>$filnam　をクリアしました！<BR><BR>";

  &oldlst_get; #最新の過去ログの拡張子を取得
  $logext = "";

#ヒアドキュメントで表示
print << "END_OF_DOC85";
<br>
<h5><font color="red">
過去ログファイルのクリア完了！！<br>
</font></h5>
$act
END_OF_DOC85
}

sub oldlog_del{
#過去ログの削除
  my($filnam) = "$bbsdir/$oldlog.$logext";
  if (!-e $filnam) { werror("該当ファイルがありません。(oldlog_del)",$filnam); }
  $rslt = unlink $filnam;
  if ($rslt == 0) { 
    werror("ログファイルは削除されませんでした。(oldlog_del)",$filnam);
    return(0);
  } else {
    print "<BR><BR>$filnam　を削除しました！<BR><BR>";
  }
  &oldlst_get; #最新の過去ログの拡張子を取得

  local(@oldlst) = split(/\t/,$extlst);
  shift @oldlst;
  my($savext) = "";
  $scnt0 = 0;
  foreach $wrkext (sort {$a cmp $b} @oldlst){ #昇順に並べ替え
    $extno = sprintf("%3.3d", $scnt0 + 1);
    if ($wrkext ne $extno) {
#print "chg $wrkext $extno";
      $rslt = rename "$bbsdir/$oldlog.$wrkext", "$bbsdir/$oldlog.$extno";
      if ($rslt != 1){
        werror("過去ログ名が変更できません。(oldlog_del)","$bbsdir/$oldlog.$wrkext->$bbsdir/$oldlog.$extno");
        last;
      } else {
        print "$oldlog.$wrkext を $oldlog.$extnoに変更しました！<BR>";
      }
    }
    $scnt0++;
  }

  &oldlst_get; #最新の過去ログの拡張子を取得
  $logext = "";

#ヒアドキュメントで表示
print << "END_OF_DOC86";
<br>
<h5><font color="red">
過去ログファイルの削除完了！！<br>
</font></h5>
$act
END_OF_DOC86
}

#---cgi end---

1;
